(* Newtonsche Polynominterpolation *)

PROGRAM newt (input,output);

  LABEL 999;

  CONST nmax = 20;
        eps  = 10E-14;

  TYPE  vector = ARRAY [1..nmax] OF real;
        matrix = ARRAY [1..nmax,1..nmax] OF real;

  VAR   i,j,n,k,itmax : integer;
        h,grenze      : real;
        x,y,z6        : vector;
        b             : matrix;


FUNCTION df (x,y,f : vector; k,i : integer) : matrix;
  FORWARD;


FUNCTION hh (x,f : vector; k,i : integer) : vector;
  FORWARD;


FUNCTION f1 (x,y : vector) : real;
BEGIN
  f1 := x[1] - y[1] + h * x[2]
END;  (*** of f1 ***)


FUNCTION f2 (x,y : vector) : real;
BEGIN
  f2 := x[2] - y[2] + h * 2 * x[1] * x[1] * x[1]
END;  (*** of f2 ***)


FUNCTION func (j : integer; x,y : vector) : real;

  VAR f : vector;

BEGIN
  CASE j OF
    1 : f[1] := f1 (x,y);
    2 : f[2] := f2 (x,y)
  END;
  func := f[j]
END;  (*** of func ***)


PROCEDURE newton (VAR x : vector; n,itmax : integer; eps : real);

  VAR g,y,f     : vector;
      w,c,p,i,j : integer;
      s,z       : real;
      a,b       : matrix;
      sch,t     : boolean;

BEGIN
  FOR i := 1 TO itmax DO
  BEGIN
    y := x;
    t := true;
    FOR j := 1 TO n DO
    BEGIN
      f[j] := func (j,x,y);
      t := (f[j] = 0) AND t
    END;
    IF t THEN
    BEGIN
      write ('(');
      FOR p := 1 TO n DO
      write (x[p],',');
      write (')');
      writeln ('    ist Nullstelle von F  ');
      GOTO 999
    END
    ELSE
      IF (i = 1) THEN
        b := df (x,y,f,k,i)
      ELSE
        IF ((i mod k) = 1) THEN
          b := df (x,y,f,k,i);
    g := hh (x,f,b,eps);
    FOR j := 1 TO n DO
      x[j] := x[j] - g[j];
    s := 0;
    z := 0;
    FOR j := 1 TO n DO
    BEGIN
      s := s + (y[i] - x[i]) * (y[i] * x[i]);
      z := z + y[i] * y[i]
    END;
    s := sqrt (s);
    z := sqrt (z);
    s := s / z;
    IF (s <= eps) THEN
    BEGIN
      writeln ('*** Relativer Fehler  < eps');
      GOTO 999
    END;
    IF (i = itmax) THEN
    BEGIN
      writeln ('*** itmax ueberschritten');
      GOTO 999
    END
  END
END;  (*** of newton ***)


FUNCTION df; (*** parameter definiert, f ***)

  CONST eps = 1E-5;

  VAR   b     : matrix;
        a     : vector;
        c,l,j : integer;

BEGIN
  FOR l := 1 TO n DO
  BEGIN
    FOR j := 1 TO n DO
      a[j] := x[j];
    a[l] := a[l] + eps;
    FOR j := 1 TO n DO
      b[j,l] := (func (j,a,y) - f[j]) / eps
  END;
  df := b
END;  (*** of df ***)


FUNCTION hh;

  VAR s,z     : real;
      g,h     : vector;
      c,r,i,j : integer;

BEGIN
  FOR i := 1 TO (n - 1) DO
  BEGIN
    s := 0;
    FOR j := i TO n DO
      s := s + b[j,i] * b[j,i];
    s := sqrt (s);
    IF (b[i,i] = 0) THEN
      z := -s
    ELSE
      z := -(b[i,i] / sqrt (b[i,i] * b[i,i])) * s;
    IF (sqrt (z * z) < eps) THEN
    BEGIN
      writeln ('sqrt (z*z) < eps)');
      GOTO 999
    END;
    FOR j := 1 TO n DO
    BEGIN
      IF (j < i) THEN
        g[j] := 0;
      IF (j = i) THEN
        g[j] := b[j,i] - z;
      IF (j > i) THEN
        g[j] := b[j,i]
    END;
    s := 0;
    FOR j := i TO n DO
      s := s + g[j] * g[j];
    s := sqrt (s);
    FOR j := i TO (n - 1) DO
    BEGIN
      g[j] := g[j] / s;
      b[j + 1,i] := g[j]
    END;
    h[i] := g[n] / s;
    b[i,i] := z;
    g[n] := g[n] / s;
    IF (sqrt (z * z) < eps) THEN
    BEGIN
      writeln ('sqrt (z*z) < eps');
      GOTO 999
    END;
    z := 0;
    FOR r := (i + 1) TO n DO
    BEGIN
      s := 0;
      FOR j := i TO n DO
        s := s + g[j] * b[r,j];
      FOR j := i TO n DO
        b[r,j] := b[r,j] - 2 * g[j] * s
    END;
    FOR j:= 1 TO n DO
      z := z + (g[j] * f[j]);
    FOR j := 1 TO n DO
      f[j] := f[j] - 2 * g[j] * z
  END;
  s := 0;
  g[n] := f[n] / b[n,n];
  FOR i := (n - 1) DOWNTO 1 DO
  BEGIN
    FOR j := (i + 1) TO n DO
      s := s + b[i,j] * g[j];
    g[i] := (f[i] - s) / (b[i,i]
  END;
  hh := g
END;  (*** of hh ***)


(*** $MAIN: newt ***)


BEGIN
  write ('Dimension: ');
  readln (n);
  write ('Anzahl der Iterationen: ');
  readln (itmax);
  writeln ('Anfangsvektor: ');
  FOR j := 1 TO n DO
  BEGIN
    write ('X[',j,'] = ');
    readln (x[j])
  END;
  write ('Nach wieviel Schritten soll B veraendert werden? ');
  readln (k);
  write ('Schrittweite = 2 hoch -i.  i = ');
  readln (i);
  h := 1;
  FOR j := 1 TO i DO
    h := h * 2;
  h := 1 / h;
  grenze := 6 / h;
  j := 0;
  WHILE (j <= grenze) DO
  BEGIN
    y := x;
    j := succ (j);
    newton (x,n,itmax,eps);
999:
  END;
  writeln (x[1],'  ',x[2]);
  z6[1] := 0.125;
  z6[2] := 0.015625;
  x[1] := x[1] - z6[1];
  x[2] := x[2] - z6[2];
  writln (x[1],'  ',x[2])
END.  (*** of main ***)
