(*** Dieses Programm soll die Zahl PI mit der Kanonen-Methode    ***)
(***        aus SPEKTRUM 6/85 mglichst genau annhern.          ***)
(*** (c) 6/1985 by Claus Sch|nleber, KIEL; claus@schoenleber.com ***)

PROGRAM pint (output,pi_file);
  VAR shots,hits,count,max_shot,count_max : integer;
      coord_x,coord_y,distance,pi         : real;
      pi_file                             : text;

FUNCTION rand : real;
  VAR cpu : real;
BEGIN
  cpu  := frac (9821 * cpu + 0.211327);
  rand := cpu
END; (* of rand *)

PROCEDURE data_in;
BEGIN
  write ('Shots   : ');
  readln (max_shot);
  write ('Series  : ');
  readln (count_max)
END; (* of data_in *)

PROCEDURE runtime;
BEGIN
  assign (pi_file,'PI.DAT');
  rewrite (pi_file);
  writeln (pi_file,count_max);
  coord_x  := 0;
  coord_y  := 0;
  distance := 0;
  pi       := 0;
  writeln;
  writeln ('Now the shooting begins...');
  gotoXY (3,7);
  write ('HITS   : ');
  gotoXY (3,9);
  write ('SERIES : ');
  FOR count := 1 TO count_max DO
  BEGIN
    gotoXY (13,9);
    write (count:5);
    hits := 0;
    FOR shots := 1 TO max_shot DO
    BEGIN
      gotoXY (13,7);
      write (hits:5);
      coord_x  := rand;
      coord_y  := rand;
      distance := sqrt ((coord_x * coord_x) + (coord_y * coord_y));
      IF (distance <= 1) THEN
        hits := hits + 1
    END;
    pi := (hits / shots * 4);
    writeln;
    writeln;
    writeln (pi_file,pi);
    gotoXY (1,11);
    writeln ('PI seems to be ',^Z'3',pi:1:7,^Z'2',' !!')
  END;
  close (pi_file)
END; (* of runtime *)

(*** MAIN ***)

BEGIN
  clrscr;
  data_in;
  runtime
END.