(* Hilfedatei
 * 
 * In vielen Programmen mchte man gerne auch einen Hilfstext auf dem Bildschirm 
 * ausgeben. Dazu wird natrlich nicht die writeln-Prozedur verwendet; das ist zu
 * wenig flexibel. Der Hilfstext wird mit Hilfe eines Editors in eine Textdatei 
 * geschrieben und bei Bedarf eingelesen und auf dem Bildschirm seitenweise ausgegeben.
 * Folgende Prozedur leistet das:
 *)

PROCEDURE show_help_file (workfile : text; _file : file_name);

  CONST wait = '--- <waiting> ---';

  VAR found  : boolean; (* Flag: File vorhanden? *)
      hline  : line; (* Arbeitszeile *)
      hlines : integer; (* Anzahl der gelisteten Zeilen *)

BEGIN
  hlines := 0;
  found := search_file (workfile,_file);
  (*** ^ kennen wir aus Kurs 1! ***)
  IF NOT found THEN
    writeln ('+++ Hilfsdatei nicht gefunden')
  ELSE
  BEGIN
    clrscr;
    hlines := 0;
    (*** Zeige den Helpfile ***)
      WHILE NOT eof (workfile) DO
      BEGIN
        hlines := succ (hlines);
        readln (workfile,hline);
        (*** Nach 22 Bildschirmzeilen Ausgabe anhalten und warten ***)
          IF (hlines < 23) THEN
            writeln (hline)
          ELSE
          BEGIN
            write (wait);
            hlines := 0;
            REPEAT
            UNTIL keypressed;
            clrscr;
            writeln (hline)
          END
      END;
      (*** Ende des Helpfiles ***)
        writeln (wait);
      REPEAT
      UNTIL keypressed;
      clrscr
  END;
  close (workfile)
END; (*** of show_help_file ***)
