(* IBM-Funktionstasten
 *
 * In Programmen auf der Serie der IBM/MS-DOS Kompatiblen hat man oftmals das Problem, 
 * Tasten abfragen zu mssen, deren Code sich aus zwei Zeichen zusammensetzt. Das 
 * einfache "readkey" aus TurboPASCAL funktioniert da nicht mehr. Also 
 * Selbstgebasteltes:
 *)

PROGRAM test;
  USES dos,crt;
  VAR c : char;

FUNCTION getkey : char;
  VAR c : char;
BEGIN
  c := readkey;
  IF (c = #0) THEN
  BEGIN
    c := readkey;
    write ('0-');
  END;
  getkey := c;
END; (*** of getkey ***)

BEGIN
  REPEAT
    c := getkey;
    writeln (ord (c));
  UNTIL (c = #27);
END.

(* Dies Programm gibt nur den Code auf dem Bildschirm aus. Will man den 
 * ermittelten Code im Programm weiterverwenden, so mu zustzlich die Information
 * zurckgegeben werden, ob eine Funktionstaste vorlag oder nur eine einfache Taste. 
 * Die Funktion mu dann wie folgt gendert werden:
 * 
 * FUNCTION getkey (VAR _flag : boolean) : char;
 *   VAR c : char;
 * BEGIN
 *   c := readkey;
 *   _flag := false;
 *   IF (c = #0) THEN
 *   BEGIN
 *     _flag := true;
 *     c := readkey;
 *   END;
 *   getkey := c;
 * END; (*** of getkey ***)
 * 
 * Der Aufruf geschieht dann zum Beispiel so:
 * VAR extended : boolean;
 * ...
 * c := getkey (extended);
 * IF extended THEN
 *   {*** ...war es eine Funktionstaste mit ***}
 *   {*** Zweizeichencode. ***}
 * ELSE
 *   {*** ...war es eine "normale" Taste" ***}
 * ...
 *)
